;;
;; /etc/emacs/site-start.d/skk-init.el
;;
;; Copyright (c) 1997, 1998 Yoshiaki Yanagiahra <yochi@debian.or.jp>
;; I release this program into public domain.
;; 1998/11/15: Modified by Fumitoshi UKAI <ukai@debian.or.jp> for 10.47.2.p1u
;;             from Debian JP release, build by Takao KAWAMURA

(setq load-path 
      (cons 
       (concat "/usr/share/" (symbol-name debian-emacs-flavor)
              "/site-lisp/skk")
       load-path))
(global-set-key "\C-x\C-j" 'skk-mode)
(global-set-key "\C-xj" 'skk-auto-fill-mode)
; (global-set-key "\C-xt" 'skk-tutorial)
(autoload 'skk-mode "skk" nil t)
(autoload 'skk-auto-fill-mode "skk" nil t)
(autoload 'skk-tutorial "skk-tut" nil t)
(setq skk-tut-file "/usr/share/skk/SKK.tut")
(autoload 'skk-isearch-mode-setup "skk-isearch" nil t)
(autoload 'skk-isearch-mode-cleanup "skk-isearch" nil t)
(add-hook 'isearch-mode-hook
          (function (lambda ()
                      (and (boundp 'skk-mode) skk-mode
                           (skk-isearch-mode-setup) ))))
(add-hook 'isearch-mode-end-hook
          (function (lambda ()
                      (and (boundp 'skk-mode) skk-mode
                           (skk-isearch-mode-cleanup)
                           (skk-set-cursor-properly) ))))
(add-hook 'minibuffer-setup-hook
          (function (lambda ()
                      (if (and (boundp 'skk-henkan-okuri-strictly)
                               skk-henkan-okuri-strictly
                               (not (eq last-command 'skk-purge-jisyo)))
                          (progn
                            (setq skk-henkan-okuri-strictly nil)
                            (put 'skk-henkan-okuri-strictly 'temporary-nil t))))))
(add-hook 'minibuffer-exit-hook
          (function (lambda ()
                      (if (get 'skk-henkan-okuri-strictly 'temporary-nil)
                          (progn
                            (put 'skk-henkan-okuri-strictly 'temporary-nil nil)
                            (setq skk-henkan-okuri-strictly t))))))

(setq skk-server-host "localhost")
;;; skk-init.el ends here
